Index: trunk/src/DPlayX/dpclassfactory.cpp
===================================================================
--- trunk/src/DPlayX/dpclassfactory.cpp	(revision 4316)
+++ trunk/src/DPlayX/dpclassfactory.cpp	(revision 4317)
@@ -1,2 +1,3 @@
+// $Id: dpclassfactory.cpp,v 1.2 2000-09-24 22:47:36 hugh Exp $
 #include <string.h>
 
Index: trunk/src/DPlayX/dpinit.h
===================================================================
--- trunk/src/DPlayX/dpinit.h	(revision 4316)
+++ trunk/src/DPlayX/dpinit.h	(revision 4317)
@@ -1,2 +1,3 @@
+// $Id: dpinit.h,v 1.2 2000-09-24 22:47:39 hugh Exp $
 
 #ifndef __WINE_DPINIT_H
@@ -8,5 +9,5 @@
 extern HRESULT DP_CreateInterface( REFIID riid, LPVOID* ppvObj );
 extern HRESULT DPL_CreateInterface( REFIID riid, LPVOID* ppvObj );
-extern HRESULT DPSP_CreateInterface( REFIID riid, LPVOID* ppvObj, 
+extern HRESULT DPSP_CreateInterface( REFIID riid, LPVOID* ppvObj,
                                      IDirectPlay2Impl* dp );
 
Index: trunk/src/DPlayX/dplay.cpp
===================================================================
--- trunk/src/DPlayX/dplay.cpp	(revision 4316)
+++ trunk/src/DPlayX/dplay.cpp	(revision 4317)
@@ -1,2 +1,3 @@
+// $Id: dplay.cpp,v 1.2 2000-09-24 22:47:36 hugh Exp $
 /* Direct Play 2,3,4 Implementation
  *
Index: trunk/src/DPlayX/dplay_global.h
===================================================================
--- trunk/src/DPlayX/dplay_global.h	(revision 4316)
+++ trunk/src/DPlayX/dplay_global.h	(revision 4317)
@@ -1,2 +1,3 @@
+// $Id: dplay_global.h,v 1.2 2000-09-24 22:47:40 hugh Exp $
 #ifndef __WINE_DPLAY_GLOBAL_INCLUDED
 #define __WINE_DPLAY_GLOBAL_INCLUDED
@@ -5,6 +6,6 @@
 #include "dplayx_queue.h"
 
-extern HRESULT DPL_EnumAddress( LPDPENUMADDRESSCALLBACK lpEnumAddressCallback, 
-                                LPCVOID lpAddress, DWORD dwAddressSize, 
+extern HRESULT DPL_EnumAddress( LPDPENUMADDRESSCALLBACK lpEnumAddressCallback,
+                                LPCVOID lpAddress, DWORD dwAddressSize,
                                 LPVOID lpContext );
 
@@ -190,5 +191,5 @@
 HRESULT DP_HandleMessage( IDirectPlay2Impl* This, LPCVOID lpMessageBody,
                           DWORD  dwMessageBodySize, LPCVOID lpMessageHeader,
-                          WORD wCommandId, WORD wVersion, 
+                          WORD wCommandId, WORD wVersion,
                           LPVOID* lplpReply, LPDWORD lpdwMsgSize );
 
Index: trunk/src/DPlayX/dplaysp.cpp
===================================================================
--- trunk/src/DPlayX/dplaysp.cpp	(revision 4316)
+++ trunk/src/DPlayX/dplaysp.cpp	(revision 4317)
@@ -1,2 +1,3 @@
+// $Id: dplaysp.cpp,v 1.2 2000-09-24 22:47:37 hugh Exp $
 /* This contains the implementation of the interface Service
  * Providers require to communicate with Direct Play
Index: trunk/src/DPlayX/dplaysp.h
===================================================================
--- trunk/src/DPlayX/dplaysp.h	(revision 4316)
+++ trunk/src/DPlayX/dplaysp.h	(revision 4317)
@@ -1,2 +1,3 @@
+// $Id: dplaysp.h,v 1.2 2000-09-24 22:47:39 hugh Exp $
 #ifndef __WINE_DIRECT_PLAY_SP_H
 #define __WINE_DIRECT_PLAY_SP_H
Index: trunk/src/DPlayX/dplayx_global.cpp
===================================================================
--- trunk/src/DPlayX/dplayx_global.cpp	(revision 4316)
+++ trunk/src/DPlayX/dplayx_global.cpp	(revision 4317)
@@ -1,2 +1,3 @@
+// $Id: dplayx_global.cpp,v 1.2 2000-09-24 22:47:37 hugh Exp $
 /* dplayx.dll global data implementation.
  *
Index: trunk/src/DPlayX/dplayx_global.h
===================================================================
--- trunk/src/DPlayX/dplayx_global.h	(revision 4316)
+++ trunk/src/DPlayX/dplayx_global.h	(revision 4317)
@@ -1,2 +1,3 @@
+// $Id: dplayx_global.h,v 1.2 2000-09-24 22:47:39 hugh Exp $
 
 #ifndef __WINE_DPLAYX_GLOBAL
@@ -8,16 +9,16 @@
 BOOL DPLAYX_DestructData(void);
 
-HRESULT DPLAYX_GetConnectionSettingsA ( DWORD dwAppID, 
-                                        LPVOID lpData, 
+HRESULT DPLAYX_GetConnectionSettingsA ( DWORD dwAppID,
+                                        LPVOID lpData,
                                         LPDWORD lpdwDataSize );
-HRESULT DPLAYX_GetConnectionSettingsW ( DWORD dwAppID, 
+HRESULT DPLAYX_GetConnectionSettingsW ( DWORD dwAppID,
                                         LPVOID lpData,
                                         LPDWORD lpdwDataSize );
 
-HRESULT DPLAYX_SetConnectionSettingsA ( DWORD dwFlags, 
-                                        DWORD dwAppID, 
+HRESULT DPLAYX_SetConnectionSettingsA ( DWORD dwFlags,
+                                        DWORD dwAppID,
                                         LPDPLCONNECTION lpConn );
-HRESULT DPLAYX_SetConnectionSettingsW ( DWORD dwFlags, 
-                                        DWORD dwAppID, 
+HRESULT DPLAYX_SetConnectionSettingsW ( DWORD dwFlags,
+                                        DWORD dwAppID,
                                         LPDPLCONNECTION lpConn );
 
@@ -28,7 +29,7 @@
 BOOL DPLAYX_AnyLobbiesWaitingForConnSettings(void);
 
-BOOL DPLAYX_SetLobbyHandles( DWORD dwAppID, 
+BOOL DPLAYX_SetLobbyHandles( DWORD dwAppID,
                              HANDLE hStart, HANDLE hDeath, HANDLE hConnRead );
-BOOL DPLAYX_GetThisLobbyHandles( LPHANDLE lphStart, 
+BOOL DPLAYX_GetThisLobbyHandles( LPHANDLE lphStart,
                                  LPHANDLE lphDeath,
                                  LPHANDLE lphConnRead, BOOL bClearSetHandles );
Index: trunk/src/DPlayX/dplayx_main.cpp
===================================================================
--- trunk/src/DPlayX/dplayx_main.cpp	(revision 4316)
+++ trunk/src/DPlayX/dplayx_main.cpp	(revision 4317)
@@ -1,2 +1,3 @@
+// $Id: dplayx_main.cpp,v 1.2 2000-09-24 22:47:37 hugh Exp $
 /*
  * DPLAYX.DLL LibMain
Index: trunk/src/DPlayX/dplayx_messages.cpp
===================================================================
--- trunk/src/DPlayX/dplayx_messages.cpp	(revision 4316)
+++ trunk/src/DPlayX/dplayx_messages.cpp	(revision 4317)
@@ -1,2 +1,3 @@
+// $Id: dplayx_messages.cpp,v 1.2 2000-09-24 22:47:38 hugh Exp $
 /* DirectPlay & DirectPlayLobby messaging implementation
  *
Index: trunk/src/DPlayX/dplayx_messages.h
===================================================================
--- trunk/src/DPlayX/dplayx_messages.h	(revision 4316)
+++ trunk/src/DPlayX/dplayx_messages.h	(revision 4317)
@@ -1,2 +1,3 @@
+// $Id: dplayx_messages.h,v 1.2 2000-09-24 22:47:39 hugh Exp $
 
 #ifndef __WINE_DPLAYX_MESSAGES__
Index: trunk/src/DPlayX/dplayx_queue.h
===================================================================
--- trunk/src/DPlayX/dplayx_queue.h	(revision 4316)
+++ trunk/src/DPlayX/dplayx_queue.h	(revision 4317)
@@ -1,4 +1,5 @@
+// $Id: dplayx_queue.h,v 1.2 2000-09-24 22:47:39 hugh Exp $
 /* A queue definition based on sys/queue.h TAILQ definitions
- * 
+ *
  * Blame any implementation mistakes on Peter Hunnisett
  * <hunnise@nortelnetworks.com>
@@ -40,5 +41,5 @@
 
 /* Check if the queue has any elements */
-#define DPQ_IS_EMPTY( head ) ( DPQ_FIRST(head) == NULL ) 
+#define DPQ_IS_EMPTY( head ) ( DPQ_FIRST(head) == NULL )
 
 /* Next entry -- FIXME: Convert everything over to this macro ... */
@@ -73,5 +74,5 @@
  * fieldToCompare - The value that we're comparing against
  * fieldCompareOperator - The logical operator to compare field and
- *                        fieldToCompare. 
+ *                        fieldToCompare.
  * rc - Variable to put the return code. Same type as (head).lpQHFirst
  */
@@ -116,5 +117,5 @@
 } while(0)
 
-/* Delete the entire queue 
+/* Delete the entire queue
  * head - pointer to the head of the queue
  * field - field to access the next elements of the queue
Index: trunk/src/DPlayX/dplobby.cpp
===================================================================
--- trunk/src/DPlayX/dplobby.cpp	(revision 4316)
+++ trunk/src/DPlayX/dplobby.cpp	(revision 4317)
@@ -1,2 +1,3 @@
+// $Id: dplobby.cpp,v 1.2 2000-09-24 22:47:38 hugh Exp $
 /* Direct Play Lobby 2 & 3 Implementation
  *
Index: trunk/src/DPlayX/name_server.cpp
===================================================================
--- trunk/src/DPlayX/name_server.cpp	(revision 4316)
+++ trunk/src/DPlayX/name_server.cpp	(revision 4317)
@@ -1,2 +1,3 @@
+// $Id: name_server.cpp,v 1.2 2000-09-24 22:47:38 hugh Exp $
 /* DPLAYX.DLL name server implementation
  *
Index: trunk/src/DPlayX/name_server.h
===================================================================
--- trunk/src/DPlayX/name_server.h	(revision 4316)
+++ trunk/src/DPlayX/name_server.h	(revision 4317)
@@ -1,2 +1,3 @@
+// $Id: name_server.h,v 1.2 2000-09-24 22:47:40 hugh Exp $
 
 #ifndef __WINE_DPLAYX_NAMESERVER
@@ -15,5 +16,5 @@
 LPVOID NS_GetNSAddr( LPVOID lpNSInfo );
 
-void NS_ReplyToEnumSessionsRequest( LPVOID lpMsg, 
+void NS_ReplyToEnumSessionsRequest( LPVOID lpMsg,
                                     LPDPSP_REPLYDATA lpReplyData,
                                     IDirectPlay2Impl* lpDP );
@@ -22,5 +23,5 @@
                                         DWORD dwFlags,
                                         LPSPINITDATA lpSpData );
-                                        
+
 
 BOOL NS_InitializeSessionCache( LPVOID* lplpNSInfo );