Index: trunk/src/ddraw/new/OS2SURFACE.CPP
===================================================================
--- trunk/src/ddraw/new/OS2SURFACE.CPP	(revision 4325)
+++ trunk/src/ddraw/new/OS2SURFACE.CPP	(revision 4326)
@@ -1,3 +1,3 @@
-/* $Id: OS2SURFACE.CPP,v 1.1 2000-04-07 18:21:05 mike Exp $ */
+/* $Id: OS2SURFACE.CPP,v 1.2 2000-09-25 20:54:01 mike Exp $ */
 
 /*
@@ -731,7 +731,5 @@
   if(NULL==DPA_SurfaceAttached)
   {
-    #ifdef DEBUG
-      dprintf(("DDRAW: Internal : Error creating DPA for attached surfaces\n"));
-    #endif
+    dprintf(("DDRAW: Internal : Error creating DPA for attached surfaces\n"));
     lastError = DDERR_OUTOFMEMORY ;
     return;
@@ -741,7 +739,5 @@
   if(NULL==DPA_LockedRects)
   {
-    #ifdef DEBUG
-      dprintf(("DDRAW: Internal : Error creating DPA for Locked Rectangles\n"));
-    #endif
+    dprintf(("DDRAW: Internal : Error creating DPA for Locked Rectangles\n"));
     lastError = DDERR_OUTOFMEMORY ;
     return;
@@ -751,7 +747,5 @@
   if(NULL==DPA_SurfacePrivateData)
   {
-    #ifdef DEBUG
-      dprintf(("DDRAW: Internal : Error creating DPA for priva surface Data\n"));
-    #endif
+    dprintf(("DDRAW: Internal : Error creating DPA for priva surface Data\n"));
     lastError = DDERR_OUTOFMEMORY ;
     return;
@@ -967,7 +961,6 @@
       // Update passed in and local Surface description
 
-      #ifdef DEBUG
-        dprintf(("DDRAW: Setting up Surface\n"));
-      #endif
+      dprintf(("DDRAW: Setting up Surface\n"));
+
       DDSurfaceDesc.dwFlags     |= DDSD_WIDTH | DDSD_HEIGHT |
                                    DDSD_PITCH | DDSD_LPSURFACE |
@@ -2192,5 +2185,5 @@
 
   #ifdef DEBUG
-    dprintf(("DDRAW: SurfBlt4 To Surf %08X, from Surf %08X\n",dest,src));
+    dprintf(("DDRAW: SurfBlt4 To Surf %08X, from Surf %08X, flags %08X", dest, src, dwFlags));
     if ( (NULL!=lpDestRect)&& (NULL!=lpSrcRect))
       dprintf(("DDRAW: SurfBlt4 to (%d,%d)(%d,%d) at %08X from (%d,%d)(%d,%d) at %08X\n", lpDestRect->left, lpDestRect->top,
@@ -2600,4 +2593,5 @@
     {
       // copy from the screen to a buffer
+      dprintf(("DDRAW: Screen to buffer"));
 
       if( (NULL==lpDestRect) &&
@@ -2665,4 +2659,5 @@
     {
       // DIVE => DIVE  or Mem => Dive can be handelt in the same way
+      dprintf(("DDRAW: Buffer to screen"));
 
       if( (src->pDiveBuffer == dest->pDiveBuffer) &&
@@ -3251,7 +3246,5 @@
   DWORD dwDestColor, dwSrcColor, BlitWidth, BlitHeight,x,y;
 
-  #ifdef DEBUG
-    dprintf(("DDRAW: SurfBltFast4 %08X at(%d/%d) onto %08X with flags %08X\n",src, dwX,dwY, dest, dwTrans));
-  #endif
+  dprintf(("DDRAW: SurfBltFast4 %08X at(%d/%d) onto %08X with flags %08X\n",src, dwX,dwY, dest, dwTrans));
 
   if( (NULL==lpDDSrcSurface) ||
@@ -3292,16 +3285,15 @@
   if(DDBLTFAST_NOCOLORKEY == dwTrans )
   {
-    dprintf(( "Solid Blit, %d bits => %d bytes per line\n",
+    dprintf(( "Solid Blit, %d pels wide => %d bytes per line\n",
               (SrcRect.right - SrcRect.left),
               BlitWidth) );
     #ifdef USE_ASM
       BltRec(pBltPos, pSrcPos, BlitWidth, BlitHeight,
-             dest->dwPitchDB,
-             src->dwPitchDB);
+             dest->dwPitchDB, src->dwPitchDB);
     #else
       // Solid Blit
       while(1)
       {
-        memcpy(pBltPos,pSrcPos,BlitWidth);
+        memcpy(pBltPos, pSrcPos, BlitWidth);
         pBltPos += dest->dwPitchDB;
         pSrcPos += src->dwPitchDB;
@@ -3316,5 +3308,5 @@
     dprintf(("DDRAW: TransBlit\n"));
 
-    if(dwTrans & DDBLTFAST_SRCCOLORKEY)
+    if (dwTrans & DDBLTFAST_SRCCOLORKEY)
     {
       dprintf(("DDRAW: Trans SRC\n"));
@@ -3581,4 +3573,5 @@
   return(DD_OK);
 }
+
 //******************************************************************************
 //******************************************************************************
@@ -3586,10 +3579,9 @@
 {
   OS2IDirectDrawSurface *me = (OS2IDirectDrawSurface *)This;
-  #ifdef DEBUG
-    dprintf(("DDRAW: SurfDeleteAttachedSurface\n"));
-  #endif
+  dprintf(("DDRAW: SurfDeleteAttachedSurface\n"));
 
   return(SurfDeleteAttachedSurface4(me, dwFlags, (LPDIRECTDRAWSURFACE4)lpDDSurface));
 }
+
 //******************************************************************************
 //******************************************************************************
Index: trunk/src/ddraw/new/os2fsdd.cpp
===================================================================
--- trunk/src/ddraw/new/os2fsdd.cpp	(revision 4325)
+++ trunk/src/ddraw/new/os2fsdd.cpp	(revision 4326)
@@ -337,6 +337,8 @@
 
   // Bail out if we aren't in FS mode
-  if (!bIsInFS)
-     return;
+  if (!bIsInFS) {
+      SetFS(sel);
+      return;
+  }
 
   // Get the anchor block